import sys, getopt, socket, timeit

def main(argv):
    mode = ''
    inputf = ''
    try:
        opts, args = getopt.getopt(argv,"m:i:",["mode=","input="])
    except getopt.GetoptError:
        print('test.py -i <inputfile> -o <outputfile>')
        sys.exit(2)
    for opt, arg in opts:
        if opt == '-h':
            print('HTTP_transfer.py -m <mode> -i <input>')
            sys.exit()
        elif opt in ("-i", "--input"):
            inputf = arg
        elif opt in ("-m", "--mode"):
            mode = arg
    print('the mode is:', mode)
    print('the input is:', inputf)
    if mode == "receive":
        ip_addr = inputf
        s = socket.socket()             # Create a socket object
        host = ip_addr  #Ip address that the TCPServer  is there
        port = 50000                     # Reserve a port for your service every new transfer wants a new port or you must wait.
        s.connect((host, port))
        s.send(b'connected')
        with open('received_file', 'wb') as f:
            print('file opened')
            while True:
                print('receiving data...')
                data = s.recv(1024)
                #print('data=%s', (data))
                if not data:
                    break
                # write data to a file
                f.write(data)
        f.close()
        print('Successfully get the file')
        s.close()
        print('connection closed')
        exit()
    if mode == "send":
        start_time = timeit.default_timer()
        file_name = inputf
        port = 50000                    # Reserve a port for your service every new transfer wants a new port or you must wait.
        s = socket.socket()             # Create a socket object
        host = ""   # Get local machine name
        s.bind((host, port))            # Bind to the port
        s.listen(5)                     # Now wait for client connection.
        print('Server listening....')
        while True:
            conn, addr = s.accept()     # Establish connection with client.
            print('Got connection from', addr)
            data = conn.recv(1024)
            print('Server received', repr(data))
            f = open(file_name,'rb')
            l = f.read(1024)
            while (l):
                conn.send(l)
                l = f.read(1024)
            f.close()
            print('Done sending')
            conn.send(b'Thank you for connecting')
            conn.close()
            elapsed = timeit.default_timer() - start_time
            print ('test elapsed time: ', elapsed)
            exit()
if __name__ == "__main__":
   main(sys.argv[1:])
